#ifndef UNICODE
#define UNICODE
#endif
#ifndef _UNICODE
#define _UNICODE
#endif
#define _X(y) y
#include <windows.h>
#define   x64
#include "TCLib\stdio.h"
#include "TCLib\string.h"
#include "TCLib\stdlib.h"
#include "TCLib\memory.h"
#include "TCLib\malloc.h"
#include "TCLib\math.h"
#include "TCLib\tchar.h"
#include "TCLib\Strings.cpp"
typedef String fstring;
FILE* stdin;
FILE* stdout;
FILE* stderr;
//<---UNICODE AWARE
#define SFMT (const char*)"%s\r\n"
//>---UNICODE AWARE

// NO HEADERS START
#ifndef _WINDOWS_
//<---UNICODE AWARE
typedef _TCHAR *PCHAR, *LPCH, *PCH, *NPSTR, *LPSTR, *PSTR;
typedef unsigned long DWORD, *PDWORD, *LPDWORD;
typedef unsigned int UINT;
//>---UNICODE AWARE
#endif
// NO HEADERS END
// ***************************************************
// Compiler Defines
// ***************************************************
#ifndef __cplusplus
#error A C++ compiler is required
#endif


typedef const _TCHAR* ccptr;
#define CCPTR const _TCHAR*
#define cfree free
//<---UNICODE AWARE
typedef char _char;
#define _strlen strlen
//>---UNICODE AWARE
#define EQU ==
#define NOT_USED(x) if(x);
#define CTLHNDL(id) GetDlgItem(hWnd,id)
#define cSizeOfDefaultString 2048

// *************************************************
//            User Defined Constants
// *************************************************

#define c_SglQt 39
#define c_DblQt 34
#define c_LPar 40
#define c_RPar 41
#define c_Komma 44
#define c_LtBkt 91
#define c_RtBkt 93


void    Pause (void);


void*   CreateArr (void*, int, int, int, size_t *);
void    DestroyArr (void**, int, int);

void *CreateArr(void *a, int elem_size, int update, int num_dims, size_t *args )
{
    size_t s, s1, s2;
    void **vp;
    size_t *marker;
    marker = args;
    s = *marker++;
    s2 = s + 2;
    if(num_dims == 1)
    {
        if(update && a)
            a = realloc(a, s2 * elem_size);
        else
            a = calloc(s2, elem_size);
        return a;
    }
    else if(update && a)
    {
        s1 = 0;
        vp = (void**)a;
        while(*vp && s1 <= s)
        {
            vp++;
            s1++;
        }
        if(s1 > s)
        {
            vp--;
            DestroyArr(vp, num_dims, 0);
        }
        a = realloc(a, s2 * sizeof(int *));
        s1 = 0;
        vp = (void**)a;
        while(*vp && s1 <= s)
        {
            vp++;
            s1++;
        }
        while(s1 < s2)
        {
            *(((void **)vp)) = NULL;
            vp++;
            s1++;
        }
    }
    else
        a = calloc(s2 * sizeof(int *), 1);
    vp = (void**)a;
    if(--num_dims > 0)
    {
        for(s1 = 0; s1 < s; s1++)
        {
            vp[s1] = CreateArr(vp[s1], elem_size, update, num_dims, marker);
        }
    }
    return a;
}


void DestroyArr (void** a, int num_dims, int top_free)
{
    int i = 0;
    static int s = 0;
    if(num_dims == 1)
    {
        free(a);
        return;
    }
    s++;
    num_dims--;
    while(a[i])
    {
        DestroyArr((void**)a[i], num_dims, top_free);
        if(num_dims > 1)
            free(a[i]);
        a[i++] = NULL;
    }
    s--;
    if(s == 0 && top_free)
        free(a);
}


struct AddressType
{
    _TCHAR Company[64];
    _TCHAR LastName[32];
    _TCHAR FirstName[32];
    _TCHAR Address1[64];
    _TCHAR Address2[64];
    _TCHAR Address3[64];
    _TCHAR CityName[24];
    _TCHAR StateName[4];
    _TCHAR ZipCode[12];
    long Country;
    _TCHAR Phone[24];
    _TCHAR Fax[24];
    _TCHAR Email[64];
    _TCHAR Url[64];
    _TCHAR Comments[1024];
};


int     _tmain (void);


AddressType *g_Address = {0};



void Pause(void)
{
    _tprintf(_T("\n%ls\n"), _T("Press any key to continue..."));
    _getwch();
}

int _tmain ()
{
    _tprintf(_T("%ls\n"), _T("Hello"));
    size_t   dimensions[1] = {5};
    g_Address = ( AddressType*) CreateArr( g_Address, sizeof( AddressType), 0, 1, dimensions);
    g_Address[0] = {_T("MyCompany#1"), _T("Last#1"), _T("First#1"), _T("Add#11"), _T("Add#12"), _T("Add#13"), _T("City#1"), _T("NY"), _T("12828"), 1, _T("111-111-1111"), _T("222-222-2222"), _T("First@Last.com"), _T(""), _T("")};
    g_Address[4] = {_T("MyCompany#4"), _T("Last#4"), _T("First#4"), _T("Add#41"), _T("Add#42"), _T("Add#43"), _T("City#4"), _T("NY"), _T("12828"), 1, _T("111-111-1111"), _T("222-222-2222"), _T("First@Last.com"), _T(""), _T("")};
    _tprintf(_T("%ls\n"), g_Address[0].StateName);
    _tprintf(_T("%ls\n"), g_Address[4].Address2);
    dimensions[1] = { 10};
    g_Address = ( AddressType*) CreateArr( g_Address, sizeof( AddressType), 1, 1, dimensions);
    g_Address[8] = {_T("MyCompany#8"), _T("Last#8"), _T("First#8"), _T("Add#81"), _T("Add#82"), _T("Add#83"), _T("City#8"), _T("NY"), _T("12828"), 1, _T("111-111-1111"), _T("222-222-2222"), _T("First@Last.com"), _T(""), _T("")};
    _tprintf(_T("%ls\n"), g_Address[0].StateName);
    _tprintf(_T("%ls\n"), g_Address[4].Address2);
    _tprintf(_T("%ls\n"), g_Address[8].CityName);
    if(g_Address )
    {
        DestroyArr((void**)g_Address, 1, 1);
        g_Address = NULL;
    }
    Pause();
}



